'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var g = require('@antv/g');
var tslib = require('tslib');
var gPluginCanvasPathGenerator = require('@antv/g-plugin-canvas-path-generator');
var gPluginImageLoader = require('@antv/g-plugin-image-loader');

function _regeneratorRuntime() {
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  _regeneratorRuntime = function () {
    return exports;
  };

  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) keys.push(key);

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return _extends.apply(this, arguments);
}

function _inheritsLoose(subClass, superClass) {
  subClass.prototype = Object.create(superClass.prototype);
  subClass.prototype.constructor = subClass;

  _setPrototypeOf(subClass, superClass);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}

/**
 * Common utilities
 * @module glMatrix
 */
// Configuration Constants
var EPSILON = 0.000001;
var ARRAY_TYPE = typeof Float32Array !== 'undefined' ? Float32Array : Array;
if (!Math.hypot) Math.hypot = function () {
  var y = 0,
      i = arguments.length;

  while (i--) {
    y += arguments[i] * arguments[i];
  }

  return Math.sqrt(y);
};

/**
 * 3x3 Matrix
 * @module mat3
 */

/**
 * Creates a new identity mat3
 *
 * @returns {mat3} a new 3x3 matrix
 */

function create() {
  var out = new ARRAY_TYPE(9);

  if (ARRAY_TYPE != Float32Array) {
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[5] = 0;
    out[6] = 0;
    out[7] = 0;
  }

  out[0] = 1;
  out[4] = 1;
  out[8] = 1;
  return out;
}

/**
 * 4x4 Matrix<br>Format: column-major, when typed out it looks like row-major<br>The matrices are being post multiplied.
 * @module mat4
 */

/**
 * Creates a new identity mat4
 *
 * @returns {mat4} a new 4x4 matrix
 */

function create$1() {
  var out = new ARRAY_TYPE(16);

  if (ARRAY_TYPE != Float32Array) {
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
  }

  out[0] = 1;
  out[5] = 1;
  out[10] = 1;
  out[15] = 1;
  return out;
}
/**
 * Returns the translation vector component of a transformation
 *  matrix. If a matrix is built with fromRotationTranslation,
 *  the returned vector will be the same as the translation vector
 *  originally supplied.
 * @param  {vec3} out Vector to receive translation component
 * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {vec3} out
 */

function getTranslation(out, mat) {
  out[0] = mat[12];
  out[1] = mat[13];
  out[2] = mat[14];
  return out;
}
/**
 * Returns the scaling factor component of a transformation
 *  matrix. If a matrix is built with fromRotationTranslationScale
 *  with a normalized Quaternion paramter, the returned vector will be
 *  the same as the scaling vector
 *  originally supplied.
 * @param  {vec3} out Vector to receive scaling factor component
 * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {vec3} out
 */

function getScaling(out, mat) {
  var m11 = mat[0];
  var m12 = mat[1];
  var m13 = mat[2];
  var m21 = mat[4];
  var m22 = mat[5];
  var m23 = mat[6];
  var m31 = mat[8];
  var m32 = mat[9];
  var m33 = mat[10];
  out[0] = Math.hypot(m11, m12, m13);
  out[1] = Math.hypot(m21, m22, m23);
  out[2] = Math.hypot(m31, m32, m33);
  return out;
}
/**
 * Returns a quaternion representing the rotational component
 *  of a transformation matrix. If a matrix is built with
 *  fromRotationTranslation, the returned quaternion will be the
 *  same as the quaternion originally supplied.
 * @param {quat} out Quaternion to receive the rotation component
 * @param {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {quat} out
 */

function getRotation(out, mat) {
  var scaling = new ARRAY_TYPE(3);
  getScaling(scaling, mat);
  var is1 = 1 / scaling[0];
  var is2 = 1 / scaling[1];
  var is3 = 1 / scaling[2];
  var sm11 = mat[0] * is1;
  var sm12 = mat[1] * is2;
  var sm13 = mat[2] * is3;
  var sm21 = mat[4] * is1;
  var sm22 = mat[5] * is2;
  var sm23 = mat[6] * is3;
  var sm31 = mat[8] * is1;
  var sm32 = mat[9] * is2;
  var sm33 = mat[10] * is3;
  var trace = sm11 + sm22 + sm33;
  var S = 0;

  if (trace > 0) {
    S = Math.sqrt(trace + 1.0) * 2;
    out[3] = 0.25 * S;
    out[0] = (sm23 - sm32) / S;
    out[1] = (sm31 - sm13) / S;
    out[2] = (sm12 - sm21) / S;
  } else if (sm11 > sm22 && sm11 > sm33) {
    S = Math.sqrt(1.0 + sm11 - sm22 - sm33) * 2;
    out[3] = (sm23 - sm32) / S;
    out[0] = 0.25 * S;
    out[1] = (sm12 + sm21) / S;
    out[2] = (sm31 + sm13) / S;
  } else if (sm22 > sm33) {
    S = Math.sqrt(1.0 + sm22 - sm11 - sm33) * 2;
    out[3] = (sm31 - sm13) / S;
    out[0] = (sm12 + sm21) / S;
    out[1] = 0.25 * S;
    out[2] = (sm23 + sm32) / S;
  } else {
    S = Math.sqrt(1.0 + sm33 - sm11 - sm22) * 2;
    out[3] = (sm12 - sm21) / S;
    out[0] = (sm31 + sm13) / S;
    out[1] = (sm23 + sm32) / S;
    out[2] = 0.25 * S;
  }

  return out;
}

/**
 * 3 Dimensional Vector
 * @module vec3
 */

/**
 * Creates a new, empty vec3
 *
 * @returns {vec3} a new 3D vector
 */

function create$2() {
  var out = new ARRAY_TYPE(3);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
  }

  return out;
}
/**
 * Calculates the length of a vec3
 *
 * @param {ReadonlyVec3} a vector to calculate length of
 * @returns {Number} length of a
 */

function length(a) {
  var x = a[0];
  var y = a[1];
  var z = a[2];
  return Math.hypot(x, y, z);
}
/**
 * Creates a new vec3 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} a new 3D vector
 */

function fromValues(x, y, z) {
  var out = new ARRAY_TYPE(3);
  out[0] = x;
  out[1] = y;
  out[2] = z;
  return out;
}
/**
 * Normalize a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to normalize
 * @returns {vec3} out
 */

function normalize(out, a) {
  var x = a[0];
  var y = a[1];
  var z = a[2];
  var len = x * x + y * y + z * z;

  if (len > 0) {
    //TODO: evaluate use of glm_invsqrt here?
    len = 1 / Math.sqrt(len);
  }

  out[0] = a[0] * len;
  out[1] = a[1] * len;
  out[2] = a[2] * len;
  return out;
}
/**
 * Calculates the dot product of two vec3's
 *
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {Number} dot product of a and b
 */

function dot(a, b) {
  return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}
/**
 * Computes the cross product of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */

function cross(out, a, b) {
  var ax = a[0],
      ay = a[1],
      az = a[2];
  var bx = b[0],
      by = b[1],
      bz = b[2];
  out[0] = ay * bz - az * by;
  out[1] = az * bx - ax * bz;
  out[2] = ax * by - ay * bx;
  return out;
}
/**
 * Alias for {@link vec3.length}
 * @function
 */

var len = length;
/**
 * Perform some operation over an array of vec3s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */

var forEach = function () {
  var vec = create$2();
  return function (a, stride, offset, count, fn, arg) {
    var i, l;

    if (!stride) {
      stride = 3;
    }

    if (!offset) {
      offset = 0;
    }

    if (count) {
      l = Math.min(count * stride + offset, a.length);
    } else {
      l = a.length;
    }

    for (i = offset; i < l; i += stride) {
      vec[0] = a[i];
      vec[1] = a[i + 1];
      vec[2] = a[i + 2];
      fn(vec, vec, arg);
      a[i] = vec[0];
      a[i + 1] = vec[1];
      a[i + 2] = vec[2];
    }

    return a;
  };
}();

/**
 * 4 Dimensional Vector
 * @module vec4
 */

/**
 * Creates a new, empty vec4
 *
 * @returns {vec4} a new 4D vector
 */

function create$3() {
  var out = new ARRAY_TYPE(4);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
  }

  return out;
}
/**
 * Normalize a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to normalize
 * @returns {vec4} out
 */

function normalize$1(out, a) {
  var x = a[0];
  var y = a[1];
  var z = a[2];
  var w = a[3];
  var len = x * x + y * y + z * z + w * w;

  if (len > 0) {
    len = 1 / Math.sqrt(len);
  }

  out[0] = x * len;
  out[1] = y * len;
  out[2] = z * len;
  out[3] = w * len;
  return out;
}
/**
 * Perform some operation over an array of vec4s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec4. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec4s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */

var forEach$1 = function () {
  var vec = create$3();
  return function (a, stride, offset, count, fn, arg) {
    var i, l;

    if (!stride) {
      stride = 4;
    }

    if (!offset) {
      offset = 0;
    }

    if (count) {
      l = Math.min(count * stride + offset, a.length);
    } else {
      l = a.length;
    }

    for (i = offset; i < l; i += stride) {
      vec[0] = a[i];
      vec[1] = a[i + 1];
      vec[2] = a[i + 2];
      vec[3] = a[i + 3];
      fn(vec, vec, arg);
      a[i] = vec[0];
      a[i + 1] = vec[1];
      a[i + 2] = vec[2];
      a[i + 3] = vec[3];
    }

    return a;
  };
}();

/**
 * Quaternion
 * @module quat
 */

/**
 * Creates a new identity quat
 *
 * @returns {quat} a new quaternion
 */

function create$4() {
  var out = new ARRAY_TYPE(4);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
  }

  out[3] = 1;
  return out;
}
/**
 * Sets a quat from the given angle and rotation axis,
 * then returns it.
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyVec3} axis the axis around which to rotate
 * @param {Number} rad the angle in radians
 * @returns {quat} out
 **/

function setAxisAngle(out, axis, rad) {
  rad = rad * 0.5;
  var s = Math.sin(rad);
  out[0] = s * axis[0];
  out[1] = s * axis[1];
  out[2] = s * axis[2];
  out[3] = Math.cos(rad);
  return out;
}
/**
 * Performs a spherical linear interpolation between two quat
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyQuat} a the first operand
 * @param {ReadonlyQuat} b the second operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {quat} out
 */

function slerp(out, a, b, t) {
  // benchmarks:
  //    http://jsperf.com/quaternion-slerp-implementations
  var ax = a[0],
      ay = a[1],
      az = a[2],
      aw = a[3];
  var bx = b[0],
      by = b[1],
      bz = b[2],
      bw = b[3];
  var omega, cosom, sinom, scale0, scale1; // calc cosine

  cosom = ax * bx + ay * by + az * bz + aw * bw; // adjust signs (if necessary)

  if (cosom < 0.0) {
    cosom = -cosom;
    bx = -bx;
    by = -by;
    bz = -bz;
    bw = -bw;
  } // calculate coefficients


  if (1.0 - cosom > EPSILON) {
    // standard case (slerp)
    omega = Math.acos(cosom);
    sinom = Math.sin(omega);
    scale0 = Math.sin((1.0 - t) * omega) / sinom;
    scale1 = Math.sin(t * omega) / sinom;
  } else {
    // "from" and "to" quaternions are very close
    //  ... so we can do a linear interpolation
    scale0 = 1.0 - t;
    scale1 = t;
  } // calculate final values


  out[0] = scale0 * ax + scale1 * bx;
  out[1] = scale0 * ay + scale1 * by;
  out[2] = scale0 * az + scale1 * bz;
  out[3] = scale0 * aw + scale1 * bw;
  return out;
}
/**
 * Creates a quaternion from the given 3x3 rotation matrix.
 *
 * NOTE: The resultant quaternion is not normalized, so you should be sure
 * to renormalize the quaternion yourself where necessary.
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyMat3} m rotation matrix
 * @returns {quat} out
 * @function
 */

function fromMat3(out, m) {
  // Algorithm in Ken Shoemake's article in 1987 SIGGRAPH course notes
  // article "Quaternion Calculus and Fast Animation".
  var fTrace = m[0] + m[4] + m[8];
  var fRoot;

  if (fTrace > 0.0) {
    // |w| > 1/2, may as well choose w > 1/2
    fRoot = Math.sqrt(fTrace + 1.0); // 2w

    out[3] = 0.5 * fRoot;
    fRoot = 0.5 / fRoot; // 1/(4w)

    out[0] = (m[5] - m[7]) * fRoot;
    out[1] = (m[6] - m[2]) * fRoot;
    out[2] = (m[1] - m[3]) * fRoot;
  } else {
    // |w| <= 1/2
    var i = 0;
    if (m[4] > m[0]) i = 1;
    if (m[8] > m[i * 3 + i]) i = 2;
    var j = (i + 1) % 3;
    var k = (i + 2) % 3;
    fRoot = Math.sqrt(m[i * 3 + i] - m[j * 3 + j] - m[k * 3 + k] + 1.0);
    out[i] = 0.5 * fRoot;
    fRoot = 0.5 / fRoot;
    out[3] = (m[j * 3 + k] - m[k * 3 + j]) * fRoot;
    out[j] = (m[j * 3 + i] + m[i * 3 + j]) * fRoot;
    out[k] = (m[k * 3 + i] + m[i * 3 + k]) * fRoot;
  }

  return out;
}
/**
 * Normalize a quat
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyQuat} a quaternion to normalize
 * @returns {quat} out
 * @function
 */

var normalize$2 = normalize$1;
/**
 * Sets a quaternion to represent the shortest rotation from one
 * vector to another.
 *
 * Both vectors are assumed to be unit length.
 *
 * @param {quat} out the receiving quaternion.
 * @param {ReadonlyVec3} a the initial vector
 * @param {ReadonlyVec3} b the destination vector
 * @returns {quat} out
 */

var rotationTo = function () {
  var tmpvec3 = create$2();
  var xUnitVec3 = fromValues(1, 0, 0);
  var yUnitVec3 = fromValues(0, 1, 0);
  return function (out, a, b) {
    var dot$1 = dot(a, b);

    if (dot$1 < -0.999999) {
      cross(tmpvec3, xUnitVec3, a);
      if (len(tmpvec3) < 0.000001) cross(tmpvec3, yUnitVec3, a);
      normalize(tmpvec3, tmpvec3);
      setAxisAngle(out, tmpvec3, Math.PI);
      return out;
    } else if (dot$1 > 0.999999) {
      out[0] = 0;
      out[1] = 0;
      out[2] = 0;
      out[3] = 1;
      return out;
    } else {
      cross(tmpvec3, a, b);
      out[0] = tmpvec3[0];
      out[1] = tmpvec3[1];
      out[2] = tmpvec3[2];
      out[3] = 1 + dot$1;
      return normalize$2(out, out);
    }
  };
}();
/**
 * Performs a spherical linear interpolation with two control points
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyQuat} a the first operand
 * @param {ReadonlyQuat} b the second operand
 * @param {ReadonlyQuat} c the third operand
 * @param {ReadonlyQuat} d the fourth operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {quat} out
 */

var sqlerp = function () {
  var temp1 = create$4();
  var temp2 = create$4();
  return function (out, a, b, c, d, t) {
    slerp(temp1, a, d, t);
    slerp(temp2, b, c, t);
    slerp(out, temp1, temp2, 2 * t * (1 - t));
    return out;
  };
}();
/**
 * Sets the specified quaternion with values corresponding to the given
 * axes. Each axis is a vec3 and is expected to be unit length and
 * perpendicular to all other specified axes.
 *
 * @param {ReadonlyVec3} view  the vector representing the viewing direction
 * @param {ReadonlyVec3} right the vector representing the local "right" direction
 * @param {ReadonlyVec3} up    the vector representing the local "up" direction
 * @returns {quat} out
 */

var setAxes = function () {
  var matr = create();
  return function (out, view, right, up) {
    matr[0] = right[0];
    matr[3] = right[1];
    matr[6] = right[2];
    matr[1] = up[0];
    matr[4] = up[1];
    matr[7] = up[2];
    matr[2] = -view[0];
    matr[5] = -view[1];
    matr[8] = -view[2];
    return normalize$2(out, fromMat3(out, matr));
  };
}();

var StyleRendererFactory = g.Syringe.defineToken('StyleRendererFactory');
var CircleRendererContribution = g.Syringe.defineToken('CircleRenderer', {
  multiple: false
});
var EllipseRendererContribution = g.Syringe.defineToken('EllipseRenderer', {
  multiple: false
});
var RectRendererContribution = g.Syringe.defineToken('RectRenderer', {
  multiple: false
});
var LineRendererContribution = g.Syringe.defineToken('LineRenderer', {
  multiple: false
});
var PolylineRendererContribution = g.Syringe.defineToken('PolylineRenderer', {
  multiple: false
});
var PolygonRendererContribution = g.Syringe.defineToken('PolygonRenderer', {
  multiple: false
});
var PathRendererContribution = g.Syringe.defineToken('PathRenderer', {
  multiple: false
});
var TextRendererContribution = g.Syringe.defineToken('TextRenderer', {
  multiple: false
});
var ImageRendererContribution = g.Syringe.defineToken('ImageRenderer', {
  multiple: false
});

exports.ImageRenderer = /*#__PURE__*/function () {
  function ImageRenderer() {
    this.imagePool = void 0;
  }

  var _proto = ImageRenderer.prototype;

  _proto.render = function render(context, parsedStyle) {
    var width = parsedStyle.width,
        height = parsedStyle.height,
        img = parsedStyle.img;
    var image;
    var iw = width.value;
    var ih = height.value;

    if (g.isString(img)) {
      // image has been loaded in `mounted` hook
      image = this.imagePool.getImageSync(img);
    } else {
      iw || (iw = img.width);
      ih || (ih = img.height);
      image = img;
    }

    if (image) {
      // node-canvas will throw the following err:
      // Error: Image given has not completed loading
      try {
        context.drawImage(image, 0, 0, iw, ih);
      } catch (e) {}
    }
  };

  return ImageRenderer;
}();

tslib.__decorate([g.inject(gPluginImageLoader.ImagePool), tslib.__metadata("design:type", gPluginImageLoader.ImagePool)], exports.ImageRenderer.prototype, "imagePool", void 0);

exports.ImageRenderer = tslib.__decorate([g.singleton({
  token: ImageRendererContribution
})], exports.ImageRenderer);

exports.TextRenderer = /*#__PURE__*/function () {
  function TextRenderer() {}

  var _proto = TextRenderer.prototype;

  _proto.render = function render(context, parsedStyle, object) {
    var lineWidth = parsedStyle.lineWidth,
        textAlign = parsedStyle.textAlign,
        textBaseline = parsedStyle.textBaseline,
        lineJoin = parsedStyle.lineJoin,
        _parsedStyle$miterLim = parsedStyle.miterLimit,
        miterLimit = _parsedStyle$miterLim === void 0 ? 0 : _parsedStyle$miterLim,
        _parsedStyle$letterSp = parsedStyle.letterSpacing,
        letterSpacing = _parsedStyle$letterSp === void 0 ? 0 : _parsedStyle$letterSp,
        stroke = parsedStyle.stroke,
        fill = parsedStyle.fill,
        fillOpacity = parsedStyle.fillOpacity,
        strokeOpacity = parsedStyle.strokeOpacity,
        opacity = parsedStyle.opacity,
        metrics = parsedStyle.metrics,
        dx = parsedStyle.dx,
        dy = parsedStyle.dy;
    var font = metrics.font,
        lines = metrics.lines,
        height = metrics.height,
        lineHeight = metrics.lineHeight,
        lineMetrics = metrics.lineMetrics;
    context.font = font;
    context.lineWidth = lineWidth.value;
    context.textAlign = textAlign.value;
    context.textBaseline = textBaseline.value;
    context.lineJoin = lineJoin.value;
    context.miterLimit = miterLimit;
    var linePositionY = 0; // handle vertical text baseline

    if (textBaseline.value === 'middle') {
      linePositionY = -height / 2 - lineHeight / 2;
    } else if (textBaseline.value === 'bottom' || textBaseline.value === 'alphabetic' || textBaseline.value === 'ideographic') {
      linePositionY = -height;
    } else if (textBaseline.value === 'top' || textBaseline.value === 'hanging') {
      linePositionY = -lineHeight;
    } // account for dx & dy


    var offsetX = 0;

    if (dx && dx.unit === g.UnitType.kPixels) {
      offsetX += dx.value;
    }

    if (dy && dy.unit === g.UnitType.kPixels) {
      linePositionY += dy.value;
    } // draw lines line by line


    for (var i = 0; i < lines.length; i++) {
      var linePositionX = lineWidth.value / 2 + offsetX;
      linePositionY += lineHeight; // no need to re-position X, cause we already set text align
      // @see https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/textAlign

      if (!g.isNil(stroke) && !stroke.isNone && lineWidth && lineWidth.value) {
        this.drawLetterSpacing(context, lines[i], lineMetrics[i], textAlign.value, linePositionX, linePositionY, letterSpacing, fillOpacity.value, strokeOpacity.value, opacity.value, true);
      }

      if (!g.isNil(fill)) {
        this.drawLetterSpacing(context, lines[i], lineMetrics[i], textAlign.value, linePositionX, linePositionY, letterSpacing, fillOpacity.value, strokeOpacity.value, opacity.value);
      }
    }
  };

  _proto.drawLetterSpacing = function drawLetterSpacing(context, text, lineMetrics, textAlign, x, y, letterSpacing, fillOpacity, strokeOpacity, opacity, isStroke) {
    if (isStroke === void 0) {
      isStroke = false;
    }

    // letterSpacing of 0 means normal, render all texts directly
    if (letterSpacing === 0) {
      if (isStroke) {
        this.strokeText(context, text, x, y, strokeOpacity);
      } else {
        this.fillText(context, text, x, y, fillOpacity, opacity);
      }

      return;
    } // draw text using left align


    var currentTextAlign = context.textAlign;
    context.textAlign = 'left';
    var currentPosition = x;

    if (textAlign === 'center') {
      currentPosition = x - lineMetrics.width / 2;
    } else if (textAlign === 'right' || textAlign === 'end') {
      currentPosition = x - lineMetrics.width;
    }

    var stringArray = Array.from(text);
    var previousWidth = context.measureText(text).width;
    var currentWidth = 0;

    for (var i = 0; i < stringArray.length; ++i) {
      var currentChar = stringArray[i];

      if (isStroke) {
        this.strokeText(context, currentChar, currentPosition, y, strokeOpacity);
      } else {
        this.fillText(context, currentChar, currentPosition, y, fillOpacity, opacity);
      }

      currentWidth = context.measureText(text.substring(i + 1)).width;
      currentPosition += previousWidth - currentWidth + letterSpacing;
      previousWidth = currentWidth;
    }

    context.textAlign = currentTextAlign;
  };

  _proto.fillText = function fillText(context, text, x, y, fillOpacity, opacity) {
    var currentGlobalAlpha;
    var applyOpacity = !g.isNil(fillOpacity) && fillOpacity !== 1;

    if (applyOpacity) {
      currentGlobalAlpha = context.globalAlpha;
      context.globalAlpha = fillOpacity * opacity;
    }

    context.fillText(text, x, y);

    if (applyOpacity) {
      context.globalAlpha = currentGlobalAlpha;
    }
  };

  _proto.strokeText = function strokeText(context, text, x, y, strokeOpacity) {
    var currentGlobalAlpha;
    var applyOpacity = !g.isNil(strokeOpacity) && strokeOpacity !== 1;

    if (applyOpacity) {
      currentGlobalAlpha = context.globalAlpha;
      context.globalAlpha = strokeOpacity;
    }

    context.strokeText(text, x, y);

    if (applyOpacity) {
      context.globalAlpha = currentGlobalAlpha;
    }
  };

  return TextRenderer;
}();

exports.TextRenderer = tslib.__decorate([g.singleton({
  token: TextRendererContribution
})], exports.TextRenderer);

var DefaultRenderer = /*#__PURE__*/function () {
  function DefaultRenderer() {
    this.imagePool = void 0;
  }

  var _proto = DefaultRenderer.prototype;

  _proto.render = function render(context, parsedStyle, object, renderingService) {
    var fill = parsedStyle.fill,
        opacity = parsedStyle.opacity,
        fillOpacity = parsedStyle.fillOpacity,
        stroke = parsedStyle.stroke,
        strokeOpacity = parsedStyle.strokeOpacity,
        lineWidth = parsedStyle.lineWidth,
        lineCap = parsedStyle.lineCap,
        lineJoin = parsedStyle.lineJoin,
        shadowColor = parsedStyle.shadowColor,
        filter = parsedStyle.filter,
        miterLimit = parsedStyle.miterLimit;
    var hasFill = !g.isNil(fill) && !fill.isNone;
    var hasStroke = !g.isNil(stroke) && !stroke.isNone;
    var isFillTransparent = fill.alpha === 0;

    if (hasFill) {
      if (!g.isNil(fillOpacity) && fillOpacity.value !== 1) {
        context.globalAlpha = fillOpacity.value;
        this.fill(context, object, fill, renderingService);
        context.globalAlpha = opacity.value;
      } else {
        this.fill(context, object, fill, renderingService);
      }
    }

    if (hasStroke) {
      if (lineWidth && lineWidth.value > 0) {
        var applyOpacity = !g.isNil(strokeOpacity) && strokeOpacity.value !== 1;

        if (applyOpacity) {
          context.globalAlpha = strokeOpacity.value;
        }

        context.lineWidth = lineWidth.value;

        if (!g.isNil(miterLimit)) {
          context.miterLimit = miterLimit;
        }

        if (!g.isNil(lineCap)) {
          context.lineCap = lineCap.value;
        }

        if (!g.isNil(lineJoin)) {
          context.lineJoin = lineJoin.value;
        }

        var oldShadowBlur;
        var oldShadowColor;
        var oldFilter;
        var hasShadowColor = !g.isNil(shadowColor);
        var hasFilter = !g.isNil(filter);

        if (hasShadowColor) {
          // prevent inner shadow when drawing stroke, toggle shadowBlur & filter(drop-shadow)
          // save shadow blur
          oldShadowBlur = context.shadowBlur;
          oldShadowColor = context.shadowColor;

          if (!g.isNil(oldShadowBlur)) {
            context.shadowColor = 'transparent';
            context.shadowBlur = 0;
          }
        }

        if (hasFilter) {
          // save drop-shadow filter
          oldFilter = context.filter;

          if (!g.isNil(oldFilter) && oldFilter.indexOf('drop-shadow') > -1) {
            context.filter = oldFilter.replace(/drop-shadow\([^)]*\)/, '').trim() || 'none';
          }
        }

        var drawStroke = hasFill && !isFillTransparent;

        if (drawStroke) {
          this.stroke(context, object, stroke, renderingService);
        } // restore shadow blur


        if (hasShadowColor) {
          context.shadowColor = oldShadowColor;
          context.shadowBlur = oldShadowBlur;
        } // restore filters


        if (hasFilter) {
          context.filter = oldFilter;
        }

        if (!drawStroke) {
          this.stroke(context, object, stroke, renderingService);
        }
      }
    }
  };

  _proto.fill = function fill(context, object, _fill, renderingService) {
    var _this = this;

    if (Array.isArray(_fill)) {
      _fill.forEach(function (gradient) {
        context.fillStyle = _this.getColor(gradient, object, context);
        context.fill();
      });
    } else {
      if (g.isPattern(_fill)) {
        context.fillStyle = this.getPattern(_fill, object, context, renderingService);
      }

      context.fill();
    }
  };

  _proto.stroke = function stroke(context, object, _stroke, renderingService) {
    var _this2 = this;

    if (Array.isArray(_stroke)) {
      _stroke.forEach(function (gradient) {
        context.strokeStyle = _this2.getColor(gradient, object, context);
        context.stroke();
      });
    } else {
      if (g.isPattern(_stroke)) {
        context.strokeStyle = this.getPattern(_stroke, object, context, renderingService);
      }

      context.stroke();
    }
  };

  _proto.getPattern = function getPattern(pattern, object, context, renderingService) {
    var canvasPattern = this.imagePool.getOrCreatePatternSync(pattern, context, function () {
      // set dirty rectangle flag
      object.renderable.dirty = true;
      renderingService.dirtify();
    });
    return canvasPattern;
  };

  _proto.getColor = function getColor(parsedColor, object, context) {
    var color;

    if (parsedColor.type === g.GradientType.LinearGradient || parsedColor.type === g.GradientType.RadialGradient) {
      var bounds = object.getGeometryBounds();
      var width = bounds && bounds.halfExtents[0] * 2 || 1;
      var height = bounds && bounds.halfExtents[1] * 2 || 1;
      color = this.imagePool.getOrCreateGradient(_extends({
        type: parsedColor.type
      }, parsedColor.value, {
        width: width,
        height: height
      }), context);
    }

    return color;
  };

  return DefaultRenderer;
}();

tslib.__decorate([g.inject(gPluginImageLoader.ImagePool), tslib.__metadata("design:type", gPluginImageLoader.ImagePool)], DefaultRenderer.prototype, "imagePool", void 0);

DefaultRenderer = tslib.__decorate([g.singleton()], DefaultRenderer);

exports.RectRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(RectRenderer, _DefaultRenderer);

  function RectRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return RectRenderer;
}(DefaultRenderer);

exports.RectRenderer = tslib.__decorate([g.singleton({
  token: RectRendererContribution
})], exports.RectRenderer);

exports.CircleRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(CircleRenderer, _DefaultRenderer);

  function CircleRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return CircleRenderer;
}(DefaultRenderer);

exports.CircleRenderer = tslib.__decorate([g.singleton({
  token: CircleRendererContribution
})], exports.CircleRenderer);

exports.EllipseRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(EllipseRenderer, _DefaultRenderer);

  function EllipseRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return EllipseRenderer;
}(DefaultRenderer);

exports.EllipseRenderer = tslib.__decorate([g.singleton({
  token: EllipseRendererContribution
})], exports.EllipseRenderer);

exports.LineRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(LineRenderer, _DefaultRenderer);

  function LineRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return LineRenderer;
}(DefaultRenderer);

exports.LineRenderer = tslib.__decorate([g.singleton({
  token: LineRendererContribution
})], exports.LineRenderer);

exports.PolylineRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(PolylineRenderer, _DefaultRenderer);

  function PolylineRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return PolylineRenderer;
}(DefaultRenderer);

exports.PolylineRenderer = tslib.__decorate([g.singleton({
  token: PolylineRendererContribution
})], exports.PolylineRenderer);

exports.PolygonRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(PolygonRenderer, _DefaultRenderer);

  function PolygonRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return PolygonRenderer;
}(DefaultRenderer);

exports.PolygonRenderer = tslib.__decorate([g.singleton({
  token: PolygonRendererContribution
})], exports.PolygonRenderer);

exports.PathRenderer = /*#__PURE__*/function (_DefaultRenderer) {
  _inheritsLoose(PathRenderer, _DefaultRenderer);

  function PathRenderer() {
    return _DefaultRenderer.apply(this, arguments) || this;
  }

  return PathRenderer;
}(DefaultRenderer);

exports.PathRenderer = tslib.__decorate([g.singleton({
  token: PathRendererContribution
})], exports.PathRenderer);

var _class;

var CanvasRendererPlugin_1;
/**
 * support 2 modes in rendering:
 * * immediate
 * * delayed: render at the end of frame with dirty-rectangle
 */

var CanvasRendererPlugin = CanvasRendererPlugin_1 = (_class = /*#__PURE__*/function () {
  function CanvasRendererPlugin() {
    this.canvasConfig = void 0;
    this.camera = void 0;
    this.contextService = void 0;
    this.renderingContext = void 0;
    this.pathGeneratorFactory = void 0;
    this.pathGeneratorFactoryCache = {};
    this.styleRendererFactory = void 0;
    this.styleRendererFactoryCache = {};
    this.displayObjectPool = void 0;
    this.rBush = void 0;
    this.removedRBushNodeAABBs = [];
    this.renderQueue = [];
    this.restoreStack = [];
    this.clearFullScreen = false;
    this.tmpVec3 = create$2();
    this.tmpMat4 = create$1();
  }

  var _proto = CanvasRendererPlugin.prototype;

  _proto.apply = function apply(renderingService) {
    var _this = this;

    var handleUnmounted = function handleUnmounted(e) {
      var object = e.target; // remove r-bush node
      // @ts-ignore

      var rBushNode = object.rBushNode;

      if (rBushNode.aabb) {
        // save removed aabbs for dirty-rectangle rendering later
        _this.removedRBushNodeAABBs.push(rBushNode.aabb);
      }
    };

    var handleCulled = function handleCulled(e) {
      var object = e.target; // @ts-ignore

      var rBushNode = object.rBushNode;

      if (rBushNode.aabb) {
        // save removed aabbs for dirty-rectangle rendering later
        _this.removedRBushNodeAABBs.push(rBushNode.aabb);
      }
    };

    renderingService.hooks.init.tapPromise(CanvasRendererPlugin_1.tag, /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      var _this$canvasConfig, width, height, context;

      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _this.renderingContext.root.addEventListener(g.ElementEvent.UNMOUNTED, handleUnmounted);

              _this.renderingContext.root.addEventListener(g.ElementEvent.CULLED, handleCulled); // clear fullscreen


              _this$canvasConfig = _this.canvasConfig, width = _this$canvasConfig.width, height = _this$canvasConfig.height;
              context = _this.contextService.getContext();

              _this.clearRect(context, 0, 0, width, height);

            case 5:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    })));
    renderingService.hooks.destroy.tap(CanvasRendererPlugin_1.tag, function () {
      _this.renderingContext.root.removeEventListener(g.ElementEvent.UNMOUNTED, handleUnmounted);

      _this.renderingContext.root.removeEventListener(g.ElementEvent.CULLED, handleCulled);
    });
    renderingService.hooks.beginFrame.tap(CanvasRendererPlugin_1.tag, function () {
      var context = _this.contextService.getContext();

      var _this$canvasConfig2 = _this.canvasConfig,
          width = _this$canvasConfig2.width,
          height = _this$canvasConfig2.height; // clear fullscreen when:
      // 1. dirty rectangle rendering disabled
      // 2. camera changed

      _this.clearFullScreen = _this.shouldClearFullScreen();

      if (context) {
        context.save();

        if (_this.clearFullScreen) {
          _this.clearRect(context, 0, 0, width, height);
        } // account for camera's world matrix


        _this.applyTransform(context, _this.camera.getOrthoMatrix());
      }
    }); // render at the end of frame

    renderingService.hooks.endFrame.tap(CanvasRendererPlugin_1.tag, function () {
      var context = _this.contextService.getContext();

      if (_this.clearFullScreen) ; else {
        // merge removed AABB
        var dirtyRenderBounds = _this.safeMergeAABB.apply(_this, [_this.mergeDirtyAABBs( // should not ignore group since clipPath may affect its children
        // this.renderQueue.filter((o) => o.nodeName !== Shape.GROUP)),
        _this.renderQueue)].concat(_this.removedRBushNodeAABBs.map(function (_ref2) {
          var minX = _ref2.minX,
              minY = _ref2.minY,
              maxX = _ref2.maxX,
              maxY = _ref2.maxY;
          var aabb = new g.AABB();
          aabb.setMinMax(fromValues(minX, minY, 0), fromValues(maxX, maxY, 0));
          return aabb;
        })));

        _this.removedRBushNodeAABBs = [];

        if (g.AABB.isEmpty(dirtyRenderBounds)) {
          _this.renderQueue = [];
          return;
        } // clear & clip dirty rectangle


        var _this$convertAABB2Rec = _this.convertAABB2Rect(dirtyRenderBounds),
            x = _this$convertAABB2Rec.x,
            y = _this$convertAABB2Rec.y,
            width = _this$convertAABB2Rec.width,
            height = _this$convertAABB2Rec.height;

        _this.clearRect(context, x, y, width, height);

        context.beginPath();
        context.rect(x, y, width, height);
        context.clip(); // draw dirty rectangle
        // if (enableDirtyRectangleRenderingDebug) {
        //   context.lineWidth = 4;
        //   context.strokeStyle = `rgba(${Math.random() * 255}, ${Math.random() * 255}, ${
        //     Math.random() * 255
        //   }, 1)`;
        //   context.strokeRect(x, y, width, height);
        // }
        // search objects intersect with dirty rectangle

        var dirtyObjects = _this.searchDirtyObjects(dirtyRenderBounds); // do rendering


        dirtyObjects // sort by z-index
        .sort(function (a, b) {
          return a.sortable.renderOrder - b.sortable.renderOrder;
        }).forEach(function (object) {
          // culled object should not be rendered
          if (object && object.isVisible() && !object.isCulled()) {
            _this.renderDisplayObject(object, renderingService);
          }
        }); // save dirty AABBs in last frame

        _this.renderQueue.forEach(function (object) {
          _this.saveDirtyAABB(object);
        }); // clear queue


        _this.renderQueue = [];
      } // pop restore stack, eg. root -> parent -> child


      _this.restoreStack.forEach(function (s) {
        context.restore();
      }); // clear restore stack


      _this.restoreStack = [];
      _this.clearFullScreen = false;
      context.restore();
    });
    renderingService.hooks.render.tap(CanvasRendererPlugin_1.tag, function (object) {
      if (_this.clearFullScreen) {
        if (object.isVisible() && !object.isCulled()) {
          // render immediately
          _this.renderDisplayObject(object, renderingService);
        }
      } else {
        // render at the end of frame
        _this.renderQueue.push(object);
      }
    });
  };

  _proto.clearRect = function clearRect(context, x, y, width, height) {
    context.clearRect(x, y, width, height);
    var background = this.canvasConfig.background;

    if (background) {
      context.fillStyle = background;
      context.fillRect(x, y, width, height);
    }
  };

  _proto.renderDisplayObject = function renderDisplayObject(object, renderingService) {
    var context = this.contextService.getContext(); // restore to its parent

    var parent = this.restoreStack[this.restoreStack.length - 1];

    while (parent && object.parentNode !== parent) {
      context.restore();
      this.restoreStack.pop();
      parent = this.restoreStack[this.restoreStack.length - 1];
    }

    var nodeName = object.nodeName;

    if (this.styleRendererFactoryCache[nodeName] === undefined) {
      this.styleRendererFactoryCache[nodeName] = this.styleRendererFactory(nodeName);
    }

    var styleRenderer = this.styleRendererFactoryCache[nodeName]; // reset transformation

    context.save(); // apply RTS transformation in world space

    this.applyTransform(context, object.getLocalTransform()); // clip path

    var clipPathShape = object.style.clipPath;

    if (clipPathShape) {
      context.save(); // const parentTransform =
      //   (object.parentElement as DisplayObject)?.getWorldTransform() || mat4.identity(this.tmpMat4);
      // mat4.multiply(this.tmpMat4, parentTransform, clipPathShape.getLocalTransform());
      // apply clip shape's RTS

      this.applyTransform(context, clipPathShape.getLocalTransform()); // generate path in local space

      if (this.pathGeneratorFactoryCache[clipPathShape.nodeName] === undefined) {
        this.pathGeneratorFactoryCache[clipPathShape.nodeName] = this.pathGeneratorFactory(clipPathShape.nodeName);
      }

      var _generatePath = this.pathGeneratorFactoryCache[clipPathShape.nodeName];

      if (_generatePath) {
        this.useAnchor(context, clipPathShape);
        context.beginPath();

        _generatePath(context, clipPathShape.parsedStyle);

        context.closePath();
      }

      context.restore();
      context.clip();
    } // fill & stroke


    context.save(); // apply attributes to context

    this.applyAttributesToContext(context, object); // apply anchor in local space

    this.useAnchor(context, object); // generate path in local space

    if (this.pathGeneratorFactoryCache[object.nodeName] === undefined) {
      this.pathGeneratorFactoryCache[object.nodeName] = this.pathGeneratorFactory(object.nodeName);
    }

    var generatePath = this.pathGeneratorFactoryCache[object.nodeName];

    if (generatePath) {
      context.beginPath();
      generatePath(context, object.parsedStyle);

      if (object.nodeName !== g.Shape.LINE && object.nodeName !== g.Shape.PATH && object.nodeName !== g.Shape.POLYLINE) {
        context.closePath();
      }
    } // fill & stroke


    if (styleRenderer) {
      styleRenderer.render(context, object.parsedStyle, object, renderingService);
    } // restore applied attributes, eg. shadowBlur shadowColor...


    context.restore(); // finish rendering, clear dirty flag

    object.renderable.dirty = false;
    this.restoreStack.push(object);
  };

  _proto.shouldClearFullScreen = function shouldClearFullScreen() {
    var renderer = this.canvasConfig.renderer;

    var _renderer$getConfig = renderer.getConfig(),
        enableDirtyRectangleRendering = _renderer$getConfig.enableDirtyRectangleRendering;

    return !enableDirtyRectangleRendering || this.renderingContext.renderReasons.has(g.RenderReason.CAMERA_CHANGED);
  };

  _proto.convertAABB2Rect = function convertAABB2Rect(aabb) {
    var min = aabb.getMin();
    var max = aabb.getMax(); // expand the rectangle a bit to avoid artifacts
    // @see https://www.yuque.com/antv/ou292n/bi8nix#ExvCu

    var minX = Math.floor(min[0]);
    var minY = Math.floor(min[1]);
    var maxX = Math.ceil(max[0]);
    var maxY = Math.ceil(max[1]);
    var width = maxX - minX;
    var height = maxY - minY;
    return {
      x: minX,
      y: minY,
      width: width,
      height: height
    };
  }
  /**
   * TODO: merge dirty rectangles with some strategies.
   * For now, we just simply merge all the rectangles into one.
   * @see https://idom.me/articles/841.html
   */
  ;

  _proto.mergeDirtyAABBs = function mergeDirtyAABBs(dirtyObjects) {
    // merge into a big AABB
    var aabb = new g.AABB();
    dirtyObjects.forEach(function (object) {
      var renderBounds = object.getRenderBounds();
      aabb.add(renderBounds);
      var dirtyRenderBounds = object.renderable.dirtyRenderBounds;

      if (dirtyRenderBounds) {
        aabb.add(dirtyRenderBounds);
      }
    });
    return aabb;
  };

  _proto.searchDirtyObjects = function searchDirtyObjects(dirtyRectangle) {
    var _this2 = this;

    // search in r-tree, get all affected nodes
    var _dirtyRectangle$getMi = dirtyRectangle.getMin(),
        minX = _dirtyRectangle$getMi[0],
        minY = _dirtyRectangle$getMi[1];

    var _dirtyRectangle$getMa = dirtyRectangle.getMax(),
        maxX = _dirtyRectangle$getMa[0],
        maxY = _dirtyRectangle$getMa[1];

    var rBushNodes = this.rBush.search({
      minX: minX,
      minY: minY,
      maxX: maxX,
      maxY: maxY
    });
    return rBushNodes.map(function (_ref3) {
      var id = _ref3.id;
      return _this2.displayObjectPool.getByEntity(id);
    });
  };

  _proto.saveDirtyAABB = function saveDirtyAABB(object) {
    var renderable = object.renderable;

    if (!renderable.dirtyRenderBounds) {
      renderable.dirtyRenderBounds = new g.AABB();
    }

    var renderBounds = object.getRenderBounds();

    if (renderBounds) {
      // save last dirty aabb
      renderable.dirtyRenderBounds.update(renderBounds.center, renderBounds.halfExtents);
    }
  };

  _proto.applyTransform = function applyTransform(context, transform) {
    var _mat4$getTranslation = getTranslation(create$2(), transform),
        tx = _mat4$getTranslation[0],
        ty = _mat4$getTranslation[1];

    var _mat4$getScaling = getScaling(create$2(), transform),
        sx = _mat4$getScaling[0],
        sy = _mat4$getScaling[1];

    var rotation = getRotation(create$4(), transform); // eslint-disable-next-line @typescript-eslint/no-unused-vars

    var _getEuler = g.getEuler(create$2(), rotation),
        eux = _getEuler[0],
        euy = _getEuler[1],
        euz = _getEuler[2]; // gimbal lock at 90 degrees


    var rts = g.fromRotationTranslationScale(eux || euz, tx, ty, sx, sy); // @see https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Transformations

    context.transform(rts[0], rts[1], rts[3], rts[4], rts[6], rts[7]);
  };

  _proto.applyAttributesToContext = function applyAttributesToContext(context, object) {
    var _object$parsedStyle = object.parsedStyle,
        stroke = _object$parsedStyle.stroke,
        fill = _object$parsedStyle.fill,
        opacity = _object$parsedStyle.opacity,
        lineDash = _object$parsedStyle.lineDash,
        lineDashOffset = _object$parsedStyle.lineDashOffset,
        filter = _object$parsedStyle.filter,
        shadowColor = _object$parsedStyle.shadowColor,
        shadowBlur = _object$parsedStyle.shadowBlur,
        shadowOffsetX = _object$parsedStyle.shadowOffsetX,
        shadowOffsetY = _object$parsedStyle.shadowOffsetY; // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/setLineDash

    if (lineDash && Array.isArray(lineDash)) {
      context.setLineDash(lineDash.map(function (segment) {
        return segment.value;
      }));
    } // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/lineDashOffset


    if (!g.isNil(lineDashOffset)) {
      context.lineDashOffset = lineDashOffset.value;
    }

    if (!g.isNil(opacity)) {
      context.globalAlpha *= opacity.value;
    }

    if (!g.isNil(stroke) && !Array.isArray(stroke) && !stroke.isNone) {
      context.strokeStyle = object.attributes.stroke;
    }

    if (!g.isNil(fill) && !Array.isArray(fill) && !fill.isNone) {
      context.fillStyle = object.attributes.fill;
    }

    if (!g.isNil(filter)) {
      // use raw filter string
      context.filter = object.style.filter;
    }

    if (!g.isNil(shadowColor)) {
      context.shadowColor = shadowColor.toString();
      context.shadowBlur = shadowBlur && shadowBlur.value || 0;
      context.shadowOffsetX = shadowOffsetX && shadowOffsetX.value || 0;
      context.shadowOffsetY = shadowOffsetY && shadowOffsetY.value || 0;
    }
  };

  _proto.useAnchor = function useAnchor(context, object) {
    var _ref4 = object.parsedStyle || {},
        anchor = _ref4.anchor;

    var bounds = object.getGeometryBounds();
    var width = bounds && bounds.halfExtents[0] * 2 || 0;
    var height = bounds && bounds.halfExtents[1] * 2 || 0;
    var tx = -((anchor && anchor[0].value || 0) * width);
    var ty = -((anchor && anchor[1].value || 0) * height);

    if (tx !== 0 || ty !== 0) {
      // apply anchor, use true size, not include stroke,
      // eg. bounds = true size + half lineWidth
      context.translate(tx, ty);
    }
  };

  _proto.safeMergeAABB = function safeMergeAABB() {
    var merged = new g.AABB();

    for (var _len = arguments.length, aabbs = new Array(_len), _key = 0; _key < _len; _key++) {
      aabbs[_key] = arguments[_key];
    }

    aabbs.forEach(function (aabb) {
      merged.add(aabb);
    });
    return merged;
  };

  return CanvasRendererPlugin;
}(), _class.tag = 'CanvasRenderer', _class);

tslib.__decorate([g.inject(g.CanvasConfig), tslib.__metadata("design:type", Object)], CanvasRendererPlugin.prototype, "canvasConfig", void 0);

tslib.__decorate([g.inject(g.DefaultCamera), tslib.__metadata("design:type", g.Camera)], CanvasRendererPlugin.prototype, "camera", void 0);

tslib.__decorate([g.inject(g.ContextService), tslib.__metadata("design:type", Object)], CanvasRendererPlugin.prototype, "contextService", void 0);

tslib.__decorate([g.inject(g.RenderingContext), tslib.__metadata("design:type", Object)], CanvasRendererPlugin.prototype, "renderingContext", void 0);

tslib.__decorate([g.inject(gPluginCanvasPathGenerator.PathGeneratorFactory), tslib.__metadata("design:type", Function)], CanvasRendererPlugin.prototype, "pathGeneratorFactory", void 0);

tslib.__decorate([g.inject(StyleRendererFactory), tslib.__metadata("design:type", Function)], CanvasRendererPlugin.prototype, "styleRendererFactory", void 0);

tslib.__decorate([g.inject(g.DisplayObjectPool), tslib.__metadata("design:type", g.DisplayObjectPool)], CanvasRendererPlugin.prototype, "displayObjectPool", void 0);

tslib.__decorate([g.inject(g.RBushRoot), tslib.__metadata("design:type", g.RBush)], CanvasRendererPlugin.prototype, "rBush", void 0);

CanvasRendererPlugin = CanvasRendererPlugin_1 = tslib.__decorate([g.singleton({
  contrib: g.RenderingPluginContribution
})], CanvasRendererPlugin);

var containerModule = g.Module(function (register) {
  var _shape2Token;

  register(exports.CircleRenderer);
  register(exports.EllipseRenderer);
  register(exports.RectRenderer);
  register(exports.ImageRenderer);
  register(exports.TextRenderer);
  register(exports.LineRenderer);
  register(exports.PolylineRenderer);
  register(exports.PolygonRenderer);
  register(exports.PathRenderer);
  var shape2Token = (_shape2Token = {}, _shape2Token[g.Shape.CIRCLE] = CircleRendererContribution, _shape2Token[g.Shape.ELLIPSE] = EllipseRendererContribution, _shape2Token[g.Shape.RECT] = RectRendererContribution, _shape2Token[g.Shape.IMAGE] = ImageRendererContribution, _shape2Token[g.Shape.TEXT] = TextRendererContribution, _shape2Token[g.Shape.LINE] = LineRendererContribution, _shape2Token[g.Shape.POLYLINE] = PolylineRendererContribution, _shape2Token[g.Shape.POLYGON] = PolygonRendererContribution, _shape2Token[g.Shape.PATH] = PathRendererContribution, _shape2Token);
  register({
    token: StyleRendererFactory,
    useFactory: function useFactory(ctx) {
      return function (tagName) {
        var token = shape2Token[tagName];

        if (token && ctx.container.isBound(token)) {
          return ctx.container.get(token);
        }

        return null;
      };
    }
  });
  register(CanvasRendererPlugin);
});
var Plugin = /*#__PURE__*/function () {
  function Plugin() {
    this.name = 'canvas-renderer';
  }

  var _proto = Plugin.prototype;

  _proto.init = function init(container) {
    container.load(containerModule, true);
  };

  _proto.destroy = function destroy(container) {
    container.unload(containerModule);
  };

  return Plugin;
}();

exports.CircleRendererContribution = CircleRendererContribution;
exports.EllipseRendererContribution = EllipseRendererContribution;
exports.ImageRendererContribution = ImageRendererContribution;
exports.LineRendererContribution = LineRendererContribution;
exports.PathRendererContribution = PathRendererContribution;
exports.Plugin = Plugin;
exports.PolygonRendererContribution = PolygonRendererContribution;
exports.PolylineRendererContribution = PolylineRendererContribution;
exports.RectRendererContribution = RectRendererContribution;
exports.StyleRendererFactory = StyleRendererFactory;
exports.TextRendererContribution = TextRendererContribution;
